
* example 1 - look for Ys;
data answers;
input id : $5. (q1-q10) (: $1.);
datalines;
A1234 Y Y Y Y Y Y Y Y N N
A2345 N N N N N N N N N N
A3456 N N N N N N N N N Y
A4567 N N N N Y N N N N N
A5678 Y N N Y N N Y N N Y
;

proc print data=answers noobs;
run;

data atleast1y;
set answers;
if find(catt(of q:),'Y');
run;

proc print data=atleast1y noobs;
run;

data atleatst1y;
set answers;
if whichc('Y', of q:);
run;

proc print data=atleast1y noobs;
run;

data atleats1y;
set answers;
array q(10);
if 'Y' in q;
run;

proc print data=atleast1y noobs;
run;

data atleast3y;
set answers;
if countc(catt(of q:),'Y') ge 3;
run;

proc print data=atleast3y noobs;
run;

* look for 1s;
data answers;
input id : $5. q1-q10;
datalines;
A1234 1 1 1 1 1 1 1 1 0 0
A2345 0 0 0 0 0 0 0 0 0 0
A3456 0 0 0 0 0 0 0 0 0 1
A4567 0 0 0 0 1 0 0 0 0 0
A5678 1 0 0 1 0 0 1 0 0 1
;

proc print data=answers noobs;
run;

data atleastone1;
set answers;
if find(catt(of q:),'1');
run;

proc print data=atleastone1 noobs;
run;

data atleastone1;
set answers;
if whichn(1, of q:);
run;

proc print data=atleastone1 noobs;
run;

data atleastone1;
set answers;
array q(10);
if 1 in q;
run;
proc print data=atleastone1 noobs;
run;

data threeones;
set answers;
if countc(catt(of q:),'1') ge 3;
run;

proc print data=threeones noobs;
run;

************************************************************************;

* example 2 - look for condition defind by a single DX code;
data diagnoses;
infile datalines truncover;
input id :$2. (dx1-dx5) (:$5.);
datalines;
01 486      5849     5990     04104    45119
02 5589     27651    5990     78079
03 51881    49121    V1582    V1251    78650
04 5781     V1042    V1041    25060    25050
05 496      4280     25040    58281    5859
06 486      496      340      311      49390
;

proc print data=diagnoses noobs;
run;

data diabetes (drop=j);
set diagnoses;
array dx(5);
do j=1 to 5 until (dx(j) eq: '250');
end;
if j lt 6;
run;

proc print data=diabetes;
run;

* IN operator;
data chosen;
set diagnoses;
if id in ('02' '05');
run;

proc print data=chosen noobs;
run;

* 558 Other and unspecified noninfectious gastroenteritis and colitis;
* 578 Gastrointestinal hemorrhage; 
data gastro;
set diagnoses;
if dx1 in : ('558' '578');
run;

proc print data=gastro noobs;
run;

* use IN with an ARRAY;
data diabetes;
set diagnoses;
array dx(5);
if '250' in : dx;
run;

proc print data=diabetes;
run;

data two_diagnoses;
set diagnoses;
array dx(5);
diabetes = '250' in : dx;
asthma   = '493' in : dx;
run;

proc print data=two_diagnoses;
run;

************************************************************************;

* example 3 - look for condition defind by a multiple DX codes; 

data diagnoses;
infile datalines missover;
input id :$2. (dx1-dx5) (:$5.);
datalines;
01 95901    78039    4280     87342    81612
02 78039    41400    4019     85301
03 82009    30501    496      2875     41400
04 9949     2765     4280     4240     78039
05 8730     9120     80001
;

proc print data=diagnoses noobs;
run;

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ;
run;

proc print data=diagnoses noobs;
format dx1-dx5 $tbi.;
run;

data tbi;
set diagnoses;
array dx(5);
do j=1 to 5 until (put(dx(j),$tbi.) eq '1');
end;
if j lt 6 then output;
drop j;
run;

proc print data=tbi;
run;

data tbi;
set diagnoses;
put @1 (dx1-dx5) ($tbi.) @;
if find(_file_,'1');
run;
 
proc print data=tbi noobs;
run;

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ' ' ='x';
run;

data tbi;
set diagnoses;
length tbi $5;
put @1 (dx1-dx5) ($tbi.) @;
*if find(_file_,'1');
tbi = _file_;
run;

proc print data=tbi noobs;
run;

proc format;
value $tbi
'800'-'80199', '803'-'80499' , '850'-'85419',  '9501'-'95039', '95901' , '99555' = '1'
other = '0' ' ' = ' ';
run;

data tbi (drop=j);
set diagnoses;
array dx(5);
array tbi(5);
do j=1 to 5;
   tbi(j) = input(put(dx(j),$tbi.),1.);
end;
run;

proc print data=tbi noobs;
run;

data tbi;
if _n_ eq 1 then input @; 
set diagnoses;
put @1 (dx1-dx5) ($tbi.) @; 
_infile_ = _file_; 
input @1 (tbi1-tbi5) (1.) @@; 
datalines; 
*
;

proc print data=tbi noobs;
run;
